#ifndef _OcclusionCullingOctreeSceneManager_H__
#define _OcclusionCullingOctreeSceneManager_H__

#include <OgreSceneNode.h>
#include <OgreOctreeSceneManager.h>
#include <OgreOctreeNode.h>
#include <OgreOctreeCamera.h>

#include "OgrePrerequisites.h"
#include "OgreOcclusionCullingOctreeSceneTraverser.h"

using namespace std;

namespace Ogre {
	/**
		Class which implements a scene mangager which uses occlusion queries for culling occluded objects
	*/
	class OcclusionCullingOctreeSceneManager: public OctreeSceneManager
	{
	public:
		OcclusionCullingOctreeSceneManager();
		~OcclusionCullingOctreeSceneManager();
	
		void _renderVisibleObjects(void);
		void _findVisibleObjects(Camera* cam, bool onlyShadowCasters);
		void _updateSceneGraph(Camera* cam);

		/** Sets the given option for the SceneManager
			       @remarks
			Options are:
			"Algorithm", int *;			
		*/
		
		virtual bool setOption( const String &, const void * );
		/** Gets the given option for the Scene Manager.
	        @remarks
		    See setOption
		*/
		virtual bool getOption( const String &, void * );

		bool getOptionValues( const String & key, StringVector &refValueList );
		bool getOptionKeys( StringVector &refKeys );

	protected:
		/** Recursively counts octree size (i.e., number of octree instances)
		@param root current octree
		*/
		//unsigned int countOctreeSize(Octree *root);

		OcclusionCullingOctreeSceneTraverser *mOcclusionCullingOctreeSceneTraverser;
	};

}
#endif // OcclusionCullingTerrainSceneManager_H